/****************************************************************************/
/* Nombre: simulador.cpp                                                    */
/* Descripcion: archivo cpp en el cual se crea el simulador de circuitos    */
/*				digitales para diagramas ASM								*/
/*				Tiene como entradas el fichero y la seal run del			*/
/*				mainwindows y como salidas un archivo con el resultado de	*/
/*				la simulacion												*/
/* Argumentos:	   															*/
/* Valor Devuelto:									                        */
/*								                                            */
/*				Trabajo Fin de Grado: David Sanz Cabreros					*/
/****************************************************************************/

/***************************** BIBLIOTECAS **********************************/
//Biblioteca con la definicion de la clase QtGui
#include <QtGui>
//Biblioteca mainwindow.h
#include "mainwindow.h"
//#include "globalDefs.h"
//#include "globalComponents.cpp"
#include "simulador.h"
#include "shared.h"

#include "stdlib.h"

//void appMessage(const QStringList &text);

//FUNCIONES PARA RESOLVER LAS EXPRESIONES
//Funcion Suma
void Suma(int &constante1, int &constante2, int &SUMA)
{
	SUMA=constante1+constante2;
}

//Funcion Resta
void Resta(int &constante1, int &constante2, int &RESTA)
{
	RESTA=constante1-constante2;
}

//Funcion Multiplicacion
void Multiplicacion(int &constante1, int &constante2, int &MULTIPLICACION)
{
	MULTIPLICACION=constante1*constante2;
}

//Funcion Division
void Division(int &constante1, int &constante2, int &DIVISION)
{
	DIVISION=constante1/constante2;
}

//Funcion Resto de la division (%)
void Porcentaje(int &constante1, int &constante2, int &PORCENTAJE)
{
	PORCENTAJE=constante1%constante2;
}

//Funcion Desplazamiento de Bits (<<, >>, >>>, <<<)
void Desplazamiento(int &Valor, int &Cantidad, int Tipo, int &Salida)
{
	//Dependiendo del tipo hace desplazamiento hacia la derecha o hacia la izquierda
	switch (Tipo)
	{	
		case 1:
			Salida = Valor << Cantidad;
			break;
		case 2:
			Salida = Valor >> Cantidad;
			break;
	}
}

//Funcion Comparacion. Salida vale 0 o 1 dependiendo si es falsa o verdadera la comparacion
void Comparacion(int &Primero, int &Segundo, int Tipo, bool &Salida)
{
	//Dependiendo del tipo hace desplazamiento hacia la derecha o hacia la izquierda
	//1 - === (Triple Igual)	2 -	!== (Negacion doble)	3 - == (Doble Igual)
	//4 - != (Negacion)			5 -	<= (Menor Igual)		6 - < (Menor)
	//7 - >= (Mayor igual)		8 - > (Mayor)
	switch (Tipo)
	{	
		case 1:
			Salida = (Primero == Segundo);
			break;
		case 2:
			Salida = (Primero != Segundo);
			break;
		case 3:
			Salida = (Primero == Segundo);
			break;
		case 4:
			Salida = (Primero != Segundo);
			break;
		case 5:
			Salida = (Primero <= Segundo);
			break;
		case 6:
			Salida = (Primero < Segundo);
			break;
		case 7:
			Salida = (Primero >= Segundo);
			break;
		case 8:
			Salida = (Primero > Segundo);
			break;
	}
}

//Funcion Logica de bit
void LogicaBit(int &Primero, int &Segundo, int Tipo, int &Salida)
{
	//Dependiendo del tipo hace desplazamiento hacia la derecha o hacia la izquierda
	//1 - & (AND)			2 -	~^ (XNOR)	
	//3 - ^ (XOR)			4 - | (OR)	
	switch (Tipo)
	{	
		case 1:
			Salida = (Primero & Segundo);
			break;
		case 2:
			Salida = ~(Primero ^ Segundo); //--------------------------------------ARREGLAR--------------//
			break;
		case 3:
			Salida = (Primero ^ Segundo);
			break;
		case 4:
			Salida = (Primero | Segundo);
			break;
	}
}

//Funcion expresion Logica. Salida vale 0 o 1 dependiendo si es falsa o verdadera la expresion
void LogicaExpr(bool &Primero, bool &Segundo, int Tipo, bool &Salida)
{
	//Dependiendo del tipo de expresion logica realiza una accion u otra
	//1 - && (AND)			2 -	|| (OR)	
	switch (Tipo)
	{	
		case 1:
			Salida = (Primero && Segundo);
			break;
		case 2:
			Salida = (Primero || Segundo);
			break;
	}
}

//Funcion Condicional. Dependiendo de si la condicion de entrada es verdadera o falsa el resultado es uno u otro
void Condicional(bool &Condicion, int &Cierto, int &Falso, int &Salida)
{
	if(Condicion==true)
	{
		Salida = Cierto;
	}
	else if(Condicion==false)
	{
		Salida = Falso;
	}
}

//Funcion Exponencia. Expresion1 ** Expresion2 = Expresion1
void Exponencia(int &Expresion1, int &Expresion2, int &Salida)
{
	Salida=1;
	for(int i=0;i<Expresion2;i++)
	{
		Salida=Salida*Expresion1;
	}
}

//Funcion Convertir Unidades. Se encarga de convertir cualquier tipo de unidad a decimal
//			-	TipoConversion = 0 -> Decimal
//			-	TipoConversion = 1 -> Binario
//			-	TipoConversion = 2 -> Octal
//			-	TipoConversion = 3 -> Hexadecimal
int ConvertirUnidades(int TipoConversion, QString &Numero)
{
	int NumeroConv=0;
	QString NumDecString;
	bool ok;

	//Decimal
	if (TipoConversion==0)
	{
		int l=0;
		while (Numero[l].isDigit() ) 
		{	
			NumDecString[l]=Numero[l];
			l++;	
		}
		
		//Guardamos el numero y borramos
		NumeroConv=NumDecString.toInt(&ok,10);
		Numero.remove(0,l);
	}
	//Binario
	if (TipoConversion==1)
	{
		////Compruebo el tamao
		//int largo=Numero.length();
		//QString Number;
		//for(int i=largo; i=0; i--)
		//{
		//	Number=Numero[i];
		//	Number.toInt(&ok,10)
		//}
		int l=0;
		while (Numero[l].isDigit() ) 
		{	
			NumDecString[l]=Numero[l];
			l++;	
		}
		
		//Guardamos el numero y borramos
		NumeroConv=NumDecString.toInt(&ok,2);
		Numero.remove(0,l);
	}
	//Octal
	if (TipoConversion==2)
	{
		int l=0;
		while (Numero[l].isDigit())
		{	
			NumDecString[l]=Numero[l];
			l++;	
		}
		
		//Guardamos el numero y borramos
		NumeroConv=NumDecString.toInt(&ok,8);
		Numero.remove(0,l);
	}
	//Hexadecimal
	if (TipoConversion==3)
	{
		int l=0;
		while	(	(Numero[l].isDigit())
				||	(Numero[l] == 'A')
				||	(Numero[l] == 'B')
				||	(Numero[l] == 'C')
				||	(Numero[l] == 'D')
				||	(Numero[l] == 'E')
				||	(Numero[l] == 'F'))
		{	
			NumDecString[l]=Numero[l];
			l++;	
		}
		
		//Guardamos el numero y borramos
		NumeroConv=NumDecString.toInt(&ok,16);
		Numero.remove(0,l);
	}

	//Devuelvo el valor del numero convertido
	return NumeroConv;
}

//Funcion encargada de analizar Strings y dependiendo de lo que encuentre devuelve un TOKEN con un valor ( definido en shared.h )
int GetToken (QString &Buffer, bool removeIt)
{

	//Borrando espacios
	int i=0;
	bool borrarEspacios=false;
	while (Buffer[i].isSpace() ) {	i++; borrarEspacios=true;	}
	if (borrarEspacios)
	{
		//Borra 1 caracter a partir de la posicin 0
		Buffer.remove(0,i);
		i=0;
	}

	//Convertimos en mayusculas el QString para que no haya problemas de reconocimiento, desde la posicion i
	//QString Buffer;
	Buffer = Buffer.toUpper();

	//Detectado buffer vacio
	if (Buffer[0] < ' ' )	return TOKEN_NULL;

	//Detectando letras
	if ( (Buffer[0].isLetter()) )
	{
		int letter=0;
		if ( (Buffer[0] == 'I')	)
		{
			if (Buffer[1] == 'N')
			{
				if ( (Buffer[2] == 'P')
					&& (Buffer[3] == 'U')
					&& (Buffer[4] == 'T'))			{ if (removeIt) Buffer.remove(0,5); letter=1; return TOKEN_INPUT;				}
				if ( (Buffer[2] == 'O')
					&& (Buffer[3] == 'U')
					&& (Buffer[4] == 'T'))			{ if (removeIt) Buffer.remove(0,5); letter=1; return TOKEN_INOUT;				}
			}
		}
		
		if ( (Buffer[0] == 'O')	)
		{
			if (Buffer[1] == 'U')
			{
				if ( (Buffer[2] == 'T')
					&& (Buffer[3] == 'P')
					&& (Buffer[4] == 'U')
					&& (Buffer[5] == 'T'))			{ if (removeIt) Buffer.remove(0,6); letter=1; return TOKEN_OUTPUT;				}
			}
		}

		if ( (Buffer[0] == 'W')	)
		{
			if (Buffer[1] == 'I')
			{
				if ( (Buffer[2] == 'R')
					&& (Buffer[3] == 'E'))			{ if (removeIt) Buffer.remove(0,4); letter=1; return TOKEN_WIRE;				}
			}
		}

		if (letter==0) 
		{
			int k=1;
			while (Buffer[k].isLetter() ) {	k++;	}
			if (removeIt) Buffer.remove(0,k);
			return TOKEN_WORD;
		}
	}

	//Detectando simbolos
	if (Buffer[0] == '?')	{ if (removeIt) Buffer.remove(0,1); return TOKEN_QUESTION;				}
	if (Buffer[0] == ':')	{ if (removeIt) Buffer.remove(0,1); return TOKEN_DOSPUNTOS;				}
	if (Buffer[0] == '|')
	{
		if	(Buffer[1] == '|')	{ if (removeIt) Buffer.remove(0,2); return TOKEN_OLOGIC;			}
		else					{ if (removeIt) Buffer.remove(0,1); return TOKEN_OR;				}
	}

	if (Buffer[0] == '&')
	{
		if	(Buffer[1] == '&')	{ if (removeIt) Buffer.remove(0,2); return TOKEN_YLOGIC;			}
		else					{ if (removeIt) Buffer.remove(0,1); return TOKEN_AND;				}
	}

	if (Buffer[0] == '^')	
	{
		if	(Buffer[1] == '~')	{ if (removeIt) Buffer.remove(0,2); return TOKEN_NXOR;				}
		else					{ if (removeIt) Buffer.remove(0,1); return TOKEN_XOR;				}
	}

	if (Buffer[0] == '~')
	{
		if	(Buffer[1] == '^')	{ if (removeIt) Buffer.remove(0,2); return TOKEN_XOR;				}
		else					{ if (removeIt) Buffer.remove(0,1); return TOKEN_NEGBIT;			}
	}

	if (Buffer[0] == '=')
	{
		if		((Buffer[1] == '=') && (Buffer[2] == '='))	{ if (removeIt) Buffer.remove(0,3); return TOKEN_TRESIGUAL;		}
		else if	(Buffer[1] == '=')							{ if (removeIt) Buffer.remove(0,2); return TOKEN_DOSIGUAL;		}
		else if	(Buffer[1] == '>')							{ if (removeIt) Buffer.remove(0,2); return TOKEN_VERIFICACION;	}
		else												{ if (removeIt) Buffer.remove(0,1); return TOKEN_IGUAL;			}
	}

	if (Buffer[0] == '!')
	{
		if		((Buffer[1] == '=') && (Buffer[2] == '='))	{ if (removeIt) Buffer.remove(0,3); return TOKEN_NOTDOSIGUAL;	}
		else if	(Buffer[1] == '=')							{ if (removeIt) Buffer.remove(0,2); return TOKEN_NOTIGUAL;		}
		else												{ if (removeIt) Buffer.remove(0,1); return TOKEN_NEGLOG;		}
	}

	if (Buffer[0] == '<')
	{
		if		((Buffer[1] == '<') && (Buffer[2] == '<'))	{ if (removeIt) Buffer.remove(0,3); return TOKEN_TRESIZQ;		}
		else if	(Buffer[1] == '<')							{ if (removeIt) Buffer.remove(0,2); return TOKEN_DOSIZQ;		}
		else if	(Buffer[1] == '=')							{ if (removeIt) Buffer.remove(0,2); return TOKEN_MENORIGUAL;	}
		else												{ if (removeIt) Buffer.remove(0,1); return TOKEN_MENOR;			}
	}

	if (Buffer[0] == '>')
	{
		if		((Buffer[1] == '>') && (Buffer[2] == '>'))	{ if (removeIt) Buffer.remove(0,3); return TOKEN_TRESDER;		}
		else if	(Buffer[1] == '>')							{ if (removeIt) Buffer.remove(0,2); return TOKEN_DOSDER;		}
		else if	(Buffer[1] == '=')							{ if (removeIt) Buffer.remove(0,2); return TOKEN_MAYORIGUAL;	}
		else												{ if (removeIt) Buffer.remove(0,1); return TOKEN_MAYOR;			}
	}

	if (Buffer[0] == '+')	{ if (removeIt) Buffer.remove(0,1); return TOKEN_MAS;					}
	if (Buffer[0] == '-')	{ if (removeIt) Buffer.remove(0,1); return TOKEN_MENOS;					}
	if (Buffer[0] == '*')	
	{ 
		if		(Buffer[1] == '*')		{ if (removeIt) Buffer.remove(0,2); return TOKEN_EXPO;				}
		else							{ if (removeIt) Buffer.remove(0,1); return TOKEN_POTENCIA;			}
	}
	
	if (Buffer[0] == '/')	{ if (removeIt) Buffer.remove(0,1); return TOKEN_DIVISION;				}
	if (Buffer[0] == '%')
	{ 
		if	((Buffer[1] == 'C') 
			&&	(Buffer[2] == 'R')
			&&	(Buffer[3] == '%'))		{ if (removeIt) Buffer.remove(0,4); return TOKEN_RETORNOCARRO;		}
		else							{ if (removeIt) Buffer.remove(0,1); return TOKEN_PORCENTAJE;		}
	}

	if (Buffer[0] == '\'')	
	{ 
		if		((Buffer[1] == 'B'))		{ if (removeIt) Buffer.remove(0,2); return TOKEN_BINARIO;		}
		else if	((Buffer[1] == 'D'))		{ if (removeIt) Buffer.remove(0,2); return TOKEN_DECIMAL;		}
		else if	((Buffer[1] == 'O'))		{ if (removeIt) Buffer.remove(0,2); return TOKEN_OCTAL;			}
		else if	((Buffer[1] == 'H'))		{ if (removeIt) Buffer.remove(0,2); return TOKEN_HEXADECIMAL;	}
		else if	((Buffer[1] == 'S'))		
		{ 
			if		((Buffer[1] == 'B'))		{ if (removeIt) Buffer.remove(0,2); return TOKEN_BINARIO;		}
			else if	((Buffer[1] == 'D'))		{ if (removeIt) Buffer.remove(0,2); return TOKEN_DECIMAL;		}
			else if	((Buffer[1] == 'O'))		{ if (removeIt) Buffer.remove(0,2); return TOKEN_OCTAL;			}
			else if	((Buffer[1] == 'H'))		{ if (removeIt) Buffer.remove(0,2); return TOKEN_HEXADECIMAL;	}
		}
		else								{ if(removeIt) Buffer.remove(0,1); return TOKEN_APOSTROFE;			}
	}

	if (Buffer[0] == '{')	{ if (removeIt) Buffer.remove(0,1); return TOKEN_CORCHOPEN;				}
	if (Buffer[0] == '}')	{ if (removeIt) Buffer.remove(0,1); return TOKEN_CORCHCLOSE;			}
	if (Buffer[0] == '(')	{ if (removeIt) Buffer.remove(0,1); return TOKEN_PARENOPEN;				}
	if (Buffer[0] == ')')	{ if (removeIt) Buffer.remove(0,1); return TOKEN_PARENCLOSE;			}
	if (Buffer[0] == '[')	{ if (removeIt) Buffer.remove(0,1); return TOKEN_QPARENOPEN;			}
	if (Buffer[0] == ']')	{ if (removeIt) Buffer.remove(0,1); return TOKEN_QPARENCLOSE;			}
	if (Buffer[0] == ',')	{ if (removeIt) Buffer.remove(0,1); return TOKEN_COMA;					}
	if (Buffer[0] == ';')	{ if (removeIt) Buffer.remove(0,1); return TOKEN_PUNTOCOMA;				}
	if (Buffer[0] == '//')	{ if (removeIt) Buffer.remove(0,1); return TOKEN_COMMENT;				}
	if (Buffer[0] == '"')	{ if (removeIt) Buffer.remove(0,1); return TOKEN_COMILLAS;				}
	if (Buffer[0] == '@')	{ if (removeIt) Buffer.remove(0,1); return TOKEN_ARROBA;				}
	if (Buffer[0] == '.')	{ if (removeIt) Buffer.remove(0,1); return TOKEN_PUNTO;					}

	//Si es un numero
	if	( Buffer[0].isNumber()	)
	{
		int j=1;
		while (Buffer[j].isDigit() ) {	j++;	}
		if (removeIt) Buffer.remove(0,j);
		return TOKEN_NUM;
	}

	//Si no es nada, devuelve error
	return TOKEN_ERROR;

}

