/****************************************************************************/
/* Nombre: simulador.h	                                                    */
/* Descripcion: biblioteca empleada para la definicion de clases del		*/
/*				simulador													*/
/* Argumentos:	   															*/
/* Valor Devuelto:									                        */
/*								                                            */
/*				Trabajo Fin de Grado: David Sanz Cabreros					*/
/****************************************************************************/

/***************************** BIBLIOTECAS **********************************/
//Biblioteca que incluye todo lo necesario para ejecutar una ventana de windows
#include <QMainWindow>
#include <QtGui>


//Definiciones de funciones empleadas en simulador.cpp
void Suma(int &constante1, int &constante2, int &SUMA);
void Resta(int &constante1, int &constante2, int &RESTA);
void Multiplicacion(int &constante1, int &constante2, int &MULTIPLICACION);
void Division(int &constante1, int &constante2, int &DIVISION);
void Porcentaje(int &constante1, int &constante2, int &PORCENTAJE);
void Desplazamiento(int &Valor, int &Cantidad, int Tipo, int &Salida);
void Comparacion(int &Primero, int &Segundo, int Tipo, bool &Salida);
void LogicaBit(int &Primero, int &Segundo, int Tipo, int &Salida);
void LogicaExpr(bool &Primero, bool &Segundo, int Tipo, bool &Salida);
void Condicional(bool &Condicion, int &Cierto, int &Falso, int &Salida);
void Exponencia(int &Expresion1, int &Expresion2, int &Salida);
int ConvertirUnidades(int TipoConversion, QString &Numero);
int GetToken(QString &buffer, bool removeIt);


//Clase para guardar las signals encontradas
class Signal
{
public:
	QString NombreSignal;
	QString CaractSignal;
	int NumParametro;																		//1 - Input, 2 - Output, 3 - Inout, 4 - Wire
	QVector<QString> InputList, OutputList, InoutList, WireList;							//Vectores para guardar los SIGNALS
	QVector<QString> CaractInput, CaractOutput, CaractInout, CaractWire;					//Vectores para guardar las caracteristicas
	QVector<QString> SyncInput, SyncOutput, SyncInout, SyncWire;							//Vectores para guardar el tipo (ASYNC - SYNC)
	QVector<int> InputValor, OutputValor, InoutValor, WireValor;							//Vectores para guardar el valor de las seales (inizializado con -1)
	QVector<int> InputValorAnt, OutputValorAnt, InoutValorAnt, WireValorAnt;				//Vectores para guardar el valor de las seales AL INICIAR EL CICLO DE SIM OPERATIVA (inizializado con -1)
	QVector<int> InputValorDesp, OutputValorDesp, InoutValorDesp, WireValorDesp;			//Vectores para guardar el valor de las seales EN EL INICIO DEL SIGUIENTE CICLO (inizializado con -1)
	QVector<QString> SignalUPEvent, SignalDOWNEvent;										//Vector para guardar los nombres de las seales que actuan en un evento (UP: seal que activa el evento; DOWN: accion del evento)
	QVector<int> SignalUPEventValor, SignalDOWNEventValor;									//Valores para lo anterior
	QVector<QString> SignalDefaultName;														//Vector que guarda los nombres de las seales por defecto
	QVector<int> SignalDefaultValor;														//Valores de las seales por defecto
};

//Clase para guardar los parametros encontrados (DE MOMENTO NO IMPLANTADO)
class Parametro
{
public:
	QString FraseParametro;
	QVector<QString> VariableList;
	int NumParametro;
};

//Clase para guardar todo lo de un modulo BOX
class Box
{
public:
	//Variables para la funcion LecturaArchivo de simulador.cpp
	QVector<int> ID;							//Guarda los ID del BOX
	QVector<QString> TYPE;						//Guarda los Type del BOX
	QVector<QVector<QString>> TEXTMatrix;		//Matriz para guardar los Textos sin resolver
	QVector<QVector<QString>> TEXTUPMatrix;		//Matriz para guardar los Textos UP sin resolver
	QVector<QVector<QString>> TEXTDOWNMatrix;	//Matriz para guardar los Textos DOWN sin resolver
	QVector<int> NEXT;							//Guarda los NEXT del BOX
	QVector<int> NEXT0;							//Guarda los NEXT0 del BOX
	QVector<int> NEXT1;							//Guarda los NEXT1 del BOX
	QVector<QString> COMMENT;					//Guarda los COMMENT del BOX (TODAVIA NO PORQUE NO LO HE HECHO)!!!!!!!!!!!!!!!!!!!!!!!!!!
	QVector<int> TOUCH;							//Nos permite saber si hemos pasado (tocado) o no por un box en la simulacin declarativa
};

//Clase para guardar todo lo de un modulo PAGES
class Pages
{
public:
	QVector<int> ID;							//Guarda los ID's de las PAGES
	QVector<QString> NAME;						//Guarda los NOMBRES de las PAGES
};

//Clase para ordenar los BOXES, y para guardar variables relativas a este
class OrdenBox
{
public:
	int IterBox;									//Iterador para la clase
	QMultiHash<QString, int> POSICION;				//QMultiHash para guardar la posicion de memoria (iterador) de cada TYPE
	QVector<int> ItCabeceras;						//Posicin del Iterador de los padres y cabeceras
	QVector<int> IdCabeceras;						//Id de los padres y cabeceras
	QVector<QString> TypeCabeceras;					//Tipo de cabecera (- Diseno: de diseo, - TestBench: de testbench)
	QVector<QVector<int>> IDStatePadresMatrix;
	QVector<QVector<int>> ITStatePadresMatrix;
};

//Clase para guardar todo lo relativo a la simulacion de los testbench
class TestBench
{
public:
	int Cantidad;				//Variable para guardar el numero de diagramas TestBench
	QVector<QString>	Nombre;	//Variable para guardar el nombre que se le da al TestBench empleado al llamar seales (Ej.: dut). 
								//En cada posicin del vector se guarda el de un testBench( Nombre	[0]			 [1]		 [2]...
								//																	[testBench 1][testBench2][.....)
};

//Clase para guardar todas las verificaciones que hay que realizar
class Verificaciones
{
public:
	QVector<int> Ciclo;				//Indica en ciclo en el que hay una verificacion
	QVector<QString> NameSignal;	//Indica el nombre de la seal
	QVector<int> Valor;				//Indica el valor de la seal en el ciclo
};

//Clase para guardar todos los datos de la simulacion
class DatosSimulacion
{
public:
	QVector<QString> SignalSim;			//Nombre de las seales
	QVector<QVector<int>> ValoresSim;	//Valor de las seales
};

//Clase para guardar todos los warning y errores que aparecen en el programa
class Fallos
{
public:
	QVector<QString> Warnings;
	QVector<QString> Errores;

};